#include<fstream>
using namespace std;
int prime(int a)
{
	int i;
	for(i=2;i*i<=a;i++)
	{
		if(a%i==0) return 0;
	}
	return 1;
}
int main()
{
	ifstream f1("BAI1_16.INP");
	ofstream f2("BAI1_16.OUT");
	int n;
	f1>>n;
	f1.close();
	int i=2;
	if(prime(n)==1) 
	{
		f2<<n;
		return 0;
	}
    while (n != 1)
    {
    	while (n%i == 0) n /= i;
    	if (n == 1) break;
    	if (i == 2) ++i;
    	else i += 2;
	}
	f2<<i;
	f2.close();
	return 0;
}
